<script type='text/javascript'>
		/*
		**   p2m_edit_position()
		*/
		function p2m_edit_position(nbr) {
			jQuery('#position_view_' + nbr).toggle();
			jQuery('#position_edit_' + nbr).toggle();
		}
		/*
		**   p2m_save_position()
		*/
		function p2m_save_position(name, nbr) {

			// No duplicate keys please
			if (p2m_does_position_key_exist(nbr)) {
				alert('The Position Key "'+ jQuery('#position_key_edit_' + nbr).val() + '" already extits. ');
				return false;
			}

			// Check for empty key names
			if (!jQuery('#position_key_edit_' + nbr).val()) {
				alert("<?php _e("The Position Key can not be empty!"); ?>");
				return false;
			}

			// Set up the data to save			
			var send = new Array();
			send['position']  	 = jQuery('#position_key_edit_' + nbr).val();
			send['position_old'] = jQuery('#position_key_' + nbr).text();
			send['description']  = jQuery('#position_desc_edit_' + nbr).val();
			send['before']  	 = jQuery('#position_before_edit_' + nbr).val();
			send['after'] 	 	 = jQuery('#position_after_edit_' + nbr).val();
			send['type'] 		 = 'widget';
			
			p2m_send_ajax('save_position', send, '#aj_' + nbr);
			
			var params = new Array('key', 'desc', 'before', 'after');
			//for (var param in params) {
			for (var i=0; i < params.length; i++) {
				jQuery('#position_' + params[i] + '_' + nbr).html(jQuery('#position_' + params[i] + '_edit_' + nbr).val().replace('<', '&lt;').replace('>', '&gt;')); //.replace('<', '&lt;').replace('>', '&gt;');			
			}
			
			p2m_edit_position(nbr);
		}
		/*
		**   p2m_delete_position()
		*/
		function p2m_delete_position(nbr) {
			if (confirm("<?php _e('Are you sure you want to remove the position', 'ad-minister'); ?>'" + $('position_key_' + nbr).innerHTML + "'? \n\n<?php _e('Any content attached to this position may be orphaned!', 'ad-minister'); ?>")) {
				var send = new Array();
				send['position']  = jQuery('#position_key_edit_' + nbr).val();
				p2m_send_ajax('delete_position', send, '');				
				jQuery('#position_view_' + nbr).remove();
				jQuery('#position_edit_' + nbr).remove();
			}
		}
		/*
		**   p2m_add_position()
		*/
		function p2m_add_position () {
			var html = '<?php echo addslashes(str_replace("\n", "", str_replace("\r", "", administer_get_position_template('', 9999)))); ?>';
			var nbr = jQuery('#widget_positions_body > *').length / 2 + jQuery('#positions_body > *').length / 2;
			html = html.replace(/9999/g, nbr);
			// new Insertion.Bottom('widget_positions_body', html);
			jQuery('#widget_positions_body').append(html);
		}
		/*
		**   p2m_edit_ad()
		*/
		function p2m_edit_ad(nbr) {
			jQuery('#ad_view_' + nbr).toggle();
			jQuery('#ad_edit_' + nbr).toggle();
		}
		
		/*
		**   p2m_save_ad ()
		**
		**   Save the ad after edit.
		*/
		function p2m_save_ad(nbr) {

			// The weight needs to be a number, unless left empty
			if (!jQuery('#ad_quota_edit_' + nbr).val().match(/^\d+$/) && jQuery('#ad_quota_edit_' + nbr).val() != '') {
				alert('<?php _e('The Weight must be a number!', 'ad-minister'); ?>');
				return 0;
			}
			
			// Handle orphaned content 
			if (!jQuery('#ad_position_edit_' + nbr).val()) 
				if (!confirm("Since you didn't change the position, the item you are saving will remain orphaned. Is this alright?", 'ad-minister')) return false;

			// Did the user change the position?
			var pos_key = jQuery('#ad_position_edit_' + nbr).val();	
			var reload = (jQuery('#ad_position_view_' + nbr).val() == pos_key || !pos_key ) ? false : true;						

			p2m_save_content (nbr);

			// Parse the scheduele
			var scheduele = jQuery('#ad_scheduele_edit_' + nbr).val();
			if (scheduele != '') {
				scheduele = scheduele.replace(/:/g, ' to ');
				jQuery('#ad_scheduele_view_' + nbr).html(' | <strong><?php _e('Scheduele', 'ad-minister'); ?>:<\/strong> ' + scheduele);
				// $('ad_scheduele_view_' + nbr).innerHTML  = ' | <strong><?php _e('Scheduele', 'ad-minister'); ?>:<\/strong> ' + scheduele;
			} else jQuery('#ad_scheduele_view_' + nbr).text('');

			// Fill in the display values
			jQuery('#ad_code_view_' + nbr).html(jQuery('#ad_code_edit_' + nbr).val()); 
			jQuery('#ad_position_view_' + nbr).val(jQuery('#ad_position_edit_' + nbr).val()); 
			jQuery('#ad_title_view_' + nbr).html(jQuery('#ad_title_edit_' + nbr).val()); 
//			jQuery('#ad_weight_view_' + nbr).text(jQuery('#ad_weight_edit_' + nbr).val()); 


//			jQuery('#ad_code_view_' + nbr).text(jQuery('#ad_code_edit_' + nbr).val()); 
//			jQuery('#ad_position_view_' + nbr).value    = $('ad_position_edit_' + nbr).value; 
			
			// Handle the 'Automatic' weight function
			if (jQuery('#ad_quota_edit_' + nbr).val()) jQuery('#ad_quota_view_' + nbr).text(jQuery('#ad_quota_edit_' + nbr).val());
			else jQuery('#ad_quota_view_' + nbr).text('Automatic');

			// Toggle the view
			p2m_edit_ad(nbr);

			// Tell user to reload page if the position changed
			if (reload == true) jQuery('#ad_position_view_div_' + nbr).after('<div style="background: #ff5555; height: 20px; padding: 20px;"><?php _e('Hey! Since you changed the position, you should now reload this page.', 'ad-minister'); ?><\/div>');
		}
		/*
		**   p2m_save_content()
		*/
		function p2m_save_content (nbr) {

			// Call ajax functions to save the changes
			send = new Array();
			send['position']     = jQuery('#ad_position_edit_' + nbr).val();
			send['position_old'] = jQuery('#ad_position_view_' + nbr).val();
			send['code']         = jQuery('#ad_code_edit_' + nbr).val();
			send['weight']       = jQuery('#ad_quota_edit_' + nbr).val();
			send['title']        = jQuery('#ad_title_edit_' + nbr).val();
			send['scheduele']    = jQuery('#ad_scheduele_edit_' + nbr).val();
			send['show']         = document.getElementById('ad_show_' + nbr).checked;
			send['wrap']         = document.getElementById('ad_wrap_edit_' + nbr).checked;
			send['id']           = nbr;
			
			// Send our data off to the server
			p2m_send_ajax('save_content', send, '#aj_' + nbr);
		}	
		/*
		**   p2m_delete_ad()
		*/
		function p2m_delete_ad(nbr) {
			if (confirm('<?php _e('Are you sure you want to remove the content', 'ad-minister'); ?> "' + $('ad_title_view_' + nbr).innerHTML + '"?')) {
				// Zero the values
				send = new Array();
				send['id'] = jQuery('#ad_id_' + nbr).val();
				p2m_send_ajax('delete_content', send, '');
				jQuery('#ad_' + nbr).remove();		
			}
		}
		/*
		**   p2m_does_position_key_exist()
		*/	
		function p2m_does_position_key_exist ( nbr ) {
			var positions = jQuery('#widget_positions_body > *');
			for (var i = 0; i < positions.length; i++) { 
				var number = positions[i].id.replace('position_view_', '');
				if (number.match(/^\d+$/) && nbr != number)
					if (jQuery('#position_key_' + number).text() == jQuery('#position_key_edit_' + nbr).val()) return true;
			}
			return false;		
		}
		/*
		**   p2m_nbr_to_add()
		*/	
		function p2m_nbr_to_add(id_prefix) {
			alert('#positions > *' + id_prefix + '*');
			
			return jQuery('#widget_positions_body > *').length / 2;
		
			// user jQuery(parent > '#boooo*')
			var not_yet = true;
			var to_add = 0;
			//while (not_yet) {
			//	alert('#' + id_prefix + to_add);
			//	if (jQuery('#' + id_prefix + to_add)) to_add++; 
			//	else not_yet = false;
			//}
			return to_add;
		}
		/*
		**   p2m_toggle_show()
		*/	
		function p2m_toggle_show (nbr) {
			p2m_save_content(nbr);
		}
		/*
		**   p2m_ready()
		*/	
		function p2m_ready(domid) {
			if (jQuery(domid)) jQuery(domid).hide();
		}		
		function p2m_preview_ad() {
			jQuery('#preview').html(jQuery('#content').val());
		}
		function p2m_send_ajax(action, send, notification_domid) {

			// Fix hardcoded path to admin...
	        var mysack = new sack("<?php bloginfo( 'wpurl' ); ?>/wp-admin/admin-ajax.php" );

			// Set the color of the notification domid
			if (notification_domid != '' && jQuery(notification_domid)) {
				jQuery(notification_domid).show();
				mysack.setVar('notification_domid', notification_domid);
			}

			// Parse the stuff we're sending out of the ass. array.			
			var nbr = 0
			for (var key in send) {
				mysack.setVar('key_' + nbr, key);	
				mysack.setVar('value_' + nbr, send[key]);	
				nbr++;
			}
			mysack.setVar('nbr_keys', nbr);

			// Setup of sack
        	mysack.execute = 1;
			mysack.method = 'POST';
			mysack.setVar('action', ('administer_' + action));
			mysack.encVar('cookie', document.cookie, false );
			mysack.onError = function() { alert('AJAX error!')};
			mysack.runAJAX();
		}

</script>