<!-- form method="post" action="options.php" name="post" -->

<h3 style="font-size: 20px;"><?php _e('Content', 'ad-minister'); ?></h3>

<p><?php _e('Click Show/Hide to see the content.', 'ad-minister'); ?></p>

<div id="ads">
<?php

	// The cshow variable will open a particular bit of content
	$cshow = $_GET['cshow'];

	$contents = get_post_meta(get_option('administer_post_id'), 'administer_content', true);
	$positions = get_post_meta(get_option('administer_post_id'), 'administer_positions', true);


echo '<pre>';
// print_r($contents);
echo '</pre>';

	// Identify orphans
	foreach ($contents as $ad)
		if (!array_key_exists($ad['position'], $positions)) $contents[$ad['id']]['position'] = '-';

	// Save the changes
	update_post_meta(get_option('administer_post_id'), 'administer_content', $contents);

	// Group the content according to position & sort
	$content = array();
	foreach($contents as $ad) {
		$content[$ad['position']][$ad['id']] = $ad;
	}
	ksort($content);

	// Create the JavaScript for toggling all of them
	$js_toggle_all = '';

	$keys = array_keys($content);
	for ($i = 0 ; $i < count($content); $i++)
		if (!empty($content[$keys[$i]]))
			$js_toggle_all .= "\$('pos_" .  $i . "').toggle(); ";
	
	?>
	
	<div class="ad_position_holder_title">
		<strong class="ad_position_key"><?php _e('Position', 'ad-minister'); ?> <span class="ad_position_count">(<?php _e('nbr', 'ad-minister'); ?>)</span></strong>
		<div class="ad_position_toggle">
			<a href='#' onclick="<?php echo $js_toggle_all; ?>; return false;"><?php _e('Show/Hide All', 'ad-minister'); ?></a>
		</div><strong class="ad_position_desc"><?php _e('Description', 'ad-minister'); ?></strong>
	</div>
	
	<?php
	
	for ($i=0; $i<count($content); $i++) {


		$desc = $positions[$keys[$i]]['description']; 
		if ($keys[$i] == '-') $desc = __('Orphaned content', 'ad-minister');
		if (!$desc) $desc = '&nbsp;';
		$index = 0;
		$position_key = ($keys[$i]) ? $keys[$i] : '-';
		$position = $content[$keys[$i]];
		// Due to how css works w. JS we can't put the visibilty with the css class.
		$display_pos = ($_GET['cshow'] == $position_key) ? '' : 'style="display: none;"';
		// p2m_position_template($i, $i);
		if (!empty($content[$keys[$i]])) {
			?>
		
			<div class="ad_position_holder">
				<strong class="ad_position_key" ><?php echo $position_key; ?> <span class="ad_position_count">(<?php echo count($position); ?>)</span></strong>
				<div class="ad_position_toggle">
					<a href='#' onclick="$('pos_<?php echo $i; ?>').toggle(); return false;"><?php _e('Show/Hide', 'ad-minister'); ?></a>
				</div>
				<strong class="ad_position_desc"> <?php echo $desc; ?></strong>
			</div>

			<div class="ad_holder" <?php echo $display_pos; ?> id="pos_<?php echo $i; ?>">

			<?php
			foreach($position as $ad) {
				administer_content_template($ad, $index++);
			}
			echo '</div>';
		}
	}
?>
</div><!-- END ADS -->

