<?php

	global $wpdb;

	// Check to see that we have everything we need
	if ($code = $_POST['content']) {
		if (!($position = $_POST['position'])) $all_ok = false;
		else if (!($title = $_POST['title'])) $all_ok = false;
		else $all_ok = true;
	
	
		if ($all_ok) {
			$id = administer_nbr_to_save(); //$_POST['nbr_to_save'];

			$content = get_post_meta(get_option('administer_post_id'), 'administer_content', true);
			if (!is_array($content)) $content = array();
			$index = count($content);

			// Requried parameters
			$content[$id]['position'] = $position;
			$content[$id]['code'] = $code;
			$content[$id]['title'] = $title;
			$content[$id]['id'] = $id;

			// Optional parameters
			$content[$id]['scheduele'] = $_POST['scheduele'];
			$content[$id]['show'] = ($_POST['show'] == 'on') ? 'true' : 'false';
			$content[$id]['weight'] = $_POST['weight'];
			$content[$id]['wrap'] = ($_POST['wrap']) ? 'true' : 'false';

			// Save to a Custom Field
			if (!add_post_meta(get_option('administer_post_id'), 'administer_content', $content, true)) 
				update_post_meta(get_option('administer_post_id'), 'administer_content', $content);
			
			echo '<div id="message" class="updated fade"><p><strong>' . __('Saved!', 'ad-minister') . '</strong></p></div>';		

		}
	}

	$content = get_post_meta(get_option('administer_post_id'), 'administer_content', true);
	if (!is_array($content) || empty($content))
			echo '<div id="message" class="updated fade"><p><strong>' . __('There is no content! Do make some.', 'ad-minister') . '</strong></p></div>';

?>

<form method="POST" action="edit.php?page=ad-minister&tab=upload">
<?php // onSubmit="return p2m_save_made_ad();" ?>
	<h3 class="large">Create content:</h3>

	<div id="class">
		<p><?php _e('To create static content, fill in the Title, Position and the html code that constitues the content. You can set the visibility of the ad and the weight. Use the file browser below to upload and add an image/file.', 'ad-minister'); ?></p>
	</div>

	<table class="create">
		<tr class="title">
			<td class="cleft">
				<label class="create" for="title"><?php _e('Title', 'ad-minister'); ?>: </label>
			</td>
			<td>
				<input class="create" name="title" id='title' type="text">
			</td>
		</tr>

		<tr class="param">
			<td>
				<label class="create" for="content"><?php _e('Html code', 'ad-minister'); ?>:</label>
			</td>
			<td>
				<fieldset id="postdiv">
					<div id="quicktags">
						<script type='text/javascript' src='<?php echo get_option('siteurl') ?>/wp-includes/js/quicktags.js'></script>
					</div>
				<div><textarea class='mceEditor' rows='10' cols='40' name='content' id='content'></textarea></div>
					<script type="text/javascript">
						//<!--
							edCanvas = document.getElementById('content');
						//-->
					</script>
					(<?php _e('may include JavaScript, but will not execute in the preview. Add files using the file browser below.'); ?>)
				</fieldset>
			</td>
		</tr>

		<tr class="param">
			<td>
				<label class="create" for="scheduele"><?php _e('Scheduele', 'ad-minister'); ?>: </label>
			</td>
			<td>
				<input class="create" name="scheduele" type="text" id="scheduele" /><br />
				(<?php _e('Optional', 'ad-minister'); ?>, E.g. 2007-12-01:2008-01-01)				
			</td>
		</tr>

		<tr class="param">
			<td>
				<label class="create" for="weight"><?php _e('Weight', 'ad-minister'); ?>: </label>
			</td>
			<td>
				<input class="create" name="weight" type="text" id="weight" /><br />
				(<?php _e('Optional, should be a number', 'ad-minister'); ?>)
			</td>
		</tr>

		<tr class="param">
			<td>
				<label class="create" for="ad_position_edit_"><?php _e('Position', 'ad-minister'); ?></label>
			</td>
			<td>
				<?php echo administer_position_select(); ?>
			</td>
		</tr>

		<tr class="param">
			<td>
				<label class="create" for="show"><?php _e('Make visible?', 'ad-minister'); ?></label>
			</td>
			<td>
				<label><input name="show" type="checkbox" id="show" checked="checked" /> (<?php _e('tick for yes', 'ad-minister'); ?>)</label>
			</td>
		</tr>

		<tr class="param">
			<td>
				<label class="create" for="wrap"><?php _e('Use wrapper?', 'ad-minister'); ?></label>
			</td>
			<td>
				<label><input name="wrap" type="checkbox" id="wrap" checked="checked" /> (<?php _e('tick for yes', 'ad-minister'); ?>)</label>			</td>
		</tr>
		<tr>
			<td></td>
			<td>
				<input type="hidden" name="page" value="ad-minister/ad-minister.php">
				<input type="button" value="<?php _e('Preview', 'ad-minister'); ?>" onclick="p2m_preview_ad(); return false;">
				<input type="submit" value="<?php _e('Save', 'ad-minister'); ?>">
			</td>
		<tr>
	</table>

<?php /*
	<div class="title2">
		<strong class="title2"><?php _e('Title', 'ad-minister'); ?>: </strong>
		<div class="ad_field2">
			<input name="title" class="ad_field" id='ad_title_edit_' type="text" maxlength="30">
		</div>
	</div>

	<div id="create">		
		<strong class="add_option"><?php _e('Html code', 'ad-minister'); ?>:</strong>
		<div class="ad_field1">
		<fieldset id="postdiv">
			<div id="quicktags">
				<script type='text/javascript' src='<?php echo get_option('siteurl') ?>/wp-includes/js/quicktags.js'></script>
			</div>
			<div><textarea class='mceEditor' rows='10' cols='40' name='content' id='content'></textarea></div>
			<script type="text/javascript">
				//<!--
					edCanvas = document.getElementById('content');
				//-->
			</script>
			(<?php _e('may include JavaScript, but will not execute in the preview. Add files using the file browser below.'); ?>)
			</fieldset>
		</div>
	
		<p><strong class="add_option"><label for="ad_scheduele_edit_"><?php _e('Scheduele', 'ad-minister'); ?>: </label></strong><div class="ad_field2"><input name="scheduele" style="width: 99%;" type="text" id="ad_scheduele_edit_" /></div><div class="ad_field2">(<?php _e('Optional', 'ad-minister'); ?>, E.g. 2007-12-01:2008-01-01)</div></p>
		<p><strong class="add_option"><label for="ad_quota_edit_"><?php _e('Weight', 'ad-minister'); ?>: </label></strong><div class="ad_field2"><input name="weight" class="add_option" type="text" id="ad_quota_edit_" /> (<?php _e('Optional', 'ad-minister'); ?>) </div></p>
		<p><strong class="add_option"><?php _e('Position', 'ad-minister'); ?>: </strong><div class="ad_field2"><?php echo administer_position_select(); ?></div></p> 
		<p><strong class="add_option"><label for="ad_show_edit_"><?php _e('Make visible?', 'ad-minister'); ?></label></strong> <label><input name="show" type="checkbox" id="ad_show_edit_" checked="checked" /> (<?php _e('tick for yes', 'ad-minister'); ?>)</label></p>
		<p><strong class="add_option"><label for="ad_wrap_edit_"><?php _e('Use wrapper?', 'ad-minister'); ?></label></strong> <label><input name="wrap" type="checkbox" id="ad_wrap_edit_" checked="checked" /> (<?php _e('tick for yes', 'ad-minister'); ?>)</label></p>

		<div class="add_buttons" id="buttons">
			<input type="hidden" name="page" value="ad-minister/ad-minister.php">
			<input type="button" value="<?php _e('Preview', 'ad-minister'); ?>" onclick="p2m_preview_ad(); return false;">
			<input type="submit" value="<?php _e('Save', 'ad-minister'); ?>">
			<!-- input type="button" value="<?php _e('Discard', 'ad-minister'); ?>" onclick="$('content').value = ''; return false;" -->
		</div>
	</div>
	*/
	?>

</form>

	<h3><?php _e('Preview', 'ad-minister'); ?>:</h3>
	<div id="preview" ></div>
	
	<h3><?php _e('Add/manage files', 'ad-minister'); ?>:</h3>
	<p><?php _e("Click on the thumbnail of the file to get the option to insert it. Press 'Send to editor' to insert image/file.", 'ad-minister'); ?></p>

	<iframe id="uploading" name="uploading" frameborder="0" src="upload.php?style=inline&#038;tab=browse&#038;post_id=<?php echo get_option('administer_post_id'); ?>&#038;_wpnonce=4b899edbfd">This feature requires iframe support.</iframe>
